
import numpy
from apgl.graph import *
from apgl.generator import * 
import unittest

class KroneckerEpidemicGeneratorTest(unittest.TestCase):
    def setUp(self):
        numpy.set_printoptions(linewidth = 200, suppress=True)
        numpy.random.seed(21)

    def testGenerateGraph(self):
        numVertices = 3
        numFeatures = 0

        vList = VertexList(numVertices, numFeatures)
        initialGraph = SparseGraph(vList)
        initialGraph.addEdge(0, 1)
        initialGraph.addEdge(1, 2)

        for i in range(numVertices):
            initialGraph.addEdge(i, i)

        #Try a large value of k and then compute graph statistics
        k = 6
        #generator = KroneckerGenerator(initialGraph, k)
        generator = KroneckerEpidemicGenerator(initialGraph, k)
        graph = generator.generateGraph()

        subgraphIndices = []
        for i in range(k):
            subgraphIndices.append(range(numVertices**(i+1)))

        graphStats = GraphStatistics()
        stats = graphStats.sequenceScalarStats(graph, subgraphIndices)

        #Check KroneckerEpidemicGenerator +  write out I \otimes G 
        print(stats)
        print(numpy.log(stats[:, graphStats.numDirEdgesIndex])/numpy.log(stats[:, graphStats.numVerticesIndex]))