

import unittest
import numpy
from apgl.graph import *
from apgl.predictors.edge import *

class SpectralEdgePredictorTest(unittest.TestCase):
    def setUp(self):
        pass


    def testEdgePredict(self):
        numVertices = 10
        numFeatures = 1

        vList = VertexList(numVertices, numFeatures)
        graph1 = SparseGraph(vList)
        graph2 = SparseGraph(vList)

        p = 0.5
        generator = ErdosRenyiGenerator(graph1)
        generator.generateGraph(p)
        generator = ErdosRenyiGenerator(graph2)
        generator.generateGraph(p)

        print(graph1)
        print(graph2)


        degree = 2
        predictor = SpectralEdgePredictor(degree)

        i = predictor.predictEdge(graph1, graph2)

        print(i)
        
    
if __name__ == "__main__":
    #import sys;sys.argv = ['', 'Test.testName']
    unittest.main()
    