import unittest
import numpy 
from apgl.predictors.GrowthLearner import GrowthLearner
from apgl.graph import * 
 

class  GrowthLearnerTest(unittest.TestCase):
    def setUp(self):
        pass

    def testLearnModel(self):
        numVertices = 100
        numFeatures = 1

        vList = VertexList(numVertices, numFeatures)
        graph = SparseGraph(vList)

        p = 0.2
        generator = ErdosRenyiGenerator(graph)
        graph = generator.generateGraph(p)

        vertexIndices = range(0, numVertices)

        k = 2
        learner = GrowthLearner(k)

        tol = 10**-1

        #Lets test the values of alpha on a series of Erdos-Renyi graphs 
        for i in range(1, 6):
            p = float(i)/10
            graph.removeAllEdges()
            graph = generator.generateGraph(p)

            alpha = learner.learnModel(graph, vertexIndices)
            print(numpy.linalg.norm(alpha - numpy.array([p, 0])))
            #self.assertTrue(numpy.linalg.norm(alpha - numpy.array([p, 0])) < tol)


        #Now test the learning on some preferencial attachment graphs
        ell = 10
        m = 8

        vertexIndices = range(ell, numVertices)
        graph.removeAllEdges()
        generator = BarabasiAlbertGenerator(graph)
        graph = generator.generateGraph(ell, m)

        alpha = learner.learnModel(graph, vertexIndices)
        print(alpha)


if __name__ == '__main__':
    unittest.main()

