import numpy
import logging
import sys
import cProfile
import pstats
import os
from apgl.graph import *
from apgl.util import *

logging.basicConfig(stream=sys.stdout, level=logging.INFO)

def profileFitDiscretePowerLaw():
    #Test with a large vector x
    alpha = 2.5
    exponent = (1/(alpha-1))
    numPoints = 50000
    x = 10*numpy.random.rand(numPoints)**-exponent
    x = numpy.array(numpy.round(x), numpy.int)
    x = x[x<=500]
    x = x[x>=1]

    xmins = numpy.arange(1, 20)

    outputDirectory = PathDefaults.getOutputDir()
    directory = outputDirectory + "test/"
    profileFileName = directory + "profile.cprof"

    logging.info("Starting to profile ...")
    cProfile.runctx('Util.fitDiscretePowerLaw(x, xmins)', globals(), locals(), profileFileName)
    stats = pstats.Stats(profileFileName)
    stats.strip_dirs().sort_stats("cumulative").print_stats(20)

profileFitDiscretePowerLaw()