

import unittest
import logging
import sys 
from apgl.viroscopy.model.HIVEpidemicModel import HIVEpidemicModel
from apgl.viroscopy.model.HIVGraph import HIVGraph
from apgl.viroscopy.model.HIVRates import HIVRates
from apgl.viroscopy.model.HIVVertices import HIVVertices
from apgl.graph import * 

class  HIVEpidemicModelTest(unittest.TestCase):
    def setUp(self):
        logging.basicConfig(stream=sys.stdout, level=logging.INFO)

        M = 100
        #Graph is one in which edges represent a contact
        undirected = True
        self.graph = HIVGraph(M, undirected)

        rates = HIVRates(self.graph)
        self.model = HIVEpidemicModel(self.graph, rates)
        
    def testSimulate(self):
        T = 1.0

        self.graph.getVertexList().setInfected(0, 0.0)

        times, infectedIndices, removedIndices, graph = self.model.simulate(T)

        print(times)

        numInfects = 0
        for i in range(graph.getNumVertices()):
            if graph.getVertex(i)[HIVVertices.stateIndex] == HIVVertices==infected:
                numInfects += 1

        self.assertTrue(numInfects == 0 or times[len(times)-1] >= T)

        #TODO: Much better testing 

if __name__ == '__main__':
    unittest.main()

